/*
 Copyright (C) Johan Ceuppens 2011-2013

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _MARKOV_MATRIX_CHAIN_OPERATOR_H_
#define _MARKOV_MATRIX_CHAIN_OPERATOR_H_

#include<cstring>
#include<iostream>
#include<vector>

#include"matrix.h"
#include"markov_chain_operator.h"

namespace cola
{
template<class I>
class markov_matrix_chain_operator : public markov_chain_operator
{
public:
	markov_matrix_chain_operator();
	markov_matrix_chain_operator(markov_matrix_chain_operator const& s);
	virtual ~markov_matrix_chain_operator();

	markov_matrix_chain_operator& operator=(markov_matrix_chain_operator const& s);
	// operator ++ transforms a matrix state 
	markov_matrix_chain_operator& operator++(matrix<I> const& m); 
};

} //namespace cola
#endif
